package cn.efunbox.audio.controller.res;

import cn.efunbox.audio.entity.res.ResWare;
import cn.efunbox.audio.page.ResOnePage;
import cn.efunbox.audio.service.res.ResWareService;
import cn.efunbox.audio.utils.ResApiCode;
import cn.efunbox.audio.utils.ResApiResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping
@Slf4j
public class ResWareController {

    @Autowired
    ResWareService resWareService;

    @RequestMapping(value = "/getContentChapterList")
    public ResApiResult<ResOnePage<ResWare>> getResWareListByContentId(@RequestHeader(value = "USERID",required = false) String USERID,
                                                                       @RequestParam(name="contentId",required = false) String contentId,
                                                                       @RequestParam(name="order",required = false) String order,
                                                                       @RequestParam(name="pageNum",required = false) Integer pageNum,
                                                                       @RequestParam(name="pageSize",required = false) Integer pageSize){
        try {
            return resWareService.getResWareListByContentId(contentId,order,pageNum,pageSize);
        } catch (Exception e) {
            log.error("getContentChapterList接口异常：{}",e.getMessage());
            return ResApiResult.error(ResApiCode.UNKNOWN_ERROR);
        }
    }

    @RequestMapping(value = "/getChapterDetail")
    public ResApiResult<ResWare> getResWareById(@RequestHeader(value = "USERID",required = false) String USERID,
                                                @RequestParam(name="chapterId",required = false) String chapterId) {
        try {
            return resWareService.getResWareById(chapterId);
        } catch (Exception e) {
            log.error("getChapterDetail接口异常：{}", e.getMessage());
            return ResApiResult.error(ResApiCode.UNKNOWN_ERROR);
        }
    }
}
