package cn.efunbox.audio.entity;


import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * 资源分组
 * Created by yao on 17-9-26.
 */


@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
public class Grouping implements Serializable, Cloneable {

    @Id
    private Long id;

    //上级组/父节点编号
    @Column
    private Long idFather = 0L;

    //是否还有子节点
    @Column
    private Boolean hasSon;

    //组名称，如唐诗、宋词
    @Column
    private String name;

    @Column
    private Integer status;

    @Column
//    @Temporal(TemporalType.TIMESTAMP)
//    private Date created;
    private Timestamp created;

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }


}
