package cn.efunbox.audio.entity;


import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * 管理员操作记录
 * Created by yao on 17-9-26.
 */
@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
public class Trail implements Serializable, Cloneable {

    @Id
    private Long id;

    //管理员编号
    @Column
    private Long idAdmin = 0L;

    //操作对象,表名称
    @Column
    private String target;

    //对象id
    @Column
    private Long idTarget;

    //操作描述
    @Column
    private String text;

    @Column
//    @Temporal(TemporalType.TIMESTAMP)
//    private Date created;
    private Timestamp created;

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }


}
