package cn.efunbox.audio.repository.res;

import cn.efunbox.audio.entity.res.ResCategory;
import cn.efunbox.audio.repository.base.BasicRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.Date;
import java.util.List;

public interface ResCategoryRepository extends BasicRepository<ResCategory> {

    @Query(value = "select * from res_category where is_del = 0",nativeQuery = true)
    public List<ResCategory> getResCategoryList();

    List<ResCategory> getByGmtModifiedAfterOrderByGmtCreated(@Param(value = "gmt_created") Date gmtCreated);

    List<ResCategory> getByGmtModifiedAfterOrderByGmtCreatedDesc(@Param(value = "gmt_created") Date gmtCreated);

    @Query(value = "select * from res_category where gmt_created > ?1 order by gmt_created desc limit ?2,?3",nativeQuery = true)
    List<ResCategory> getResCategoryLimit(@Param(value = "gmt_created") String gmtCreated,@Param(value = "i") Integer i,@Param("n") Integer n);

    @Query(value = "select * from res_category where gmt_created > ?1 order by gmt_created asc limit ?2,?3",nativeQuery = true)
    List<ResCategory> getResCategoryLimit2(@Param(value = "gmt_created") String gmtCreated,@Param(value = "i") Integer i,@Param("n") Integer n);

    @Query(value = "select * from res_category where gmt_created > ?1",nativeQuery = true)
    List<ResCategory> getResCategoryLimit3(@Param(value = "gmt_created") String gmtCreated);
}
